#define CATCH_CONFIG_MAIN
#include <catch2/catch.hpp>

#include <rdbxx/RDBColumnTmplt.h>

using namespace std;

TEST_CASE( "RDBColumn Data Test Suite" ) {
  
  string name( "my column name" );
  string def( "15N< What description?" );
  RDBStringColumn c1( name, def );

  REQUIRE(  c1.getName( ) ==  name );
  REQUIRE(  c1.getDef( ) ==   def );

  string str_data( "1.1" );
  double dbl_data = 1.1;
  long lng_data = 1;
  c1.setData( str_data.c_str() );
  REQUIRE( c1.getDataString( ) == str_data );
  REQUIRE( c1.getDataDouble( ) == dbl_data );

  REQUIRE_THROWS_AS( c1.getDataLong(), RDBErr );
  c1.setThrow( false );

  REQUIRE( c1.getDataLong( ) == lng_data );
  REQUIRE( c1.getErrNo( ) ==  RDBColumn::LOSTPRECISION );
  REQUIRE( c1.getDataString( ) == str_data );
}
